import { Utilities } from '@/util/Utilities';
import {
    DialogService,
    Form,
    LoadingService,
    Modal, ModalService, Select, Text, TextInput, Number,
} from '@zeedhi/common';
import { Http, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Sm00005000TabParametrizacoesSignatariosPadroesController {
    private basicModal!: Modal;

    public modalCadastro: any;

    public async exibirModalSignatarios() {
        this.basicModal = await ModalService.createFromJson('sm_00005_000_parametrizacoes_services/modal/sm_00005_000_parametrizacoes_signatarios_padroes_modal', true);
        this.basicModal.show();
    }

    public fecharModalSignatarios() {
        this.basicModal.hide();
        this.basicModal?.destroy();
    }

    public async abrirModalSignatarios() {
        await this.exibirModalSignatarios();
        this.modalCadastro = false;
        Metadata.getInstance<Text>('titleText').text = 'Novo Signatário Padrão';
        Metadata.getInstance<TextInput>('NRINSCRICAOPARC').isVisible = false;
    }

    public async abrirModalCadastramentoAutomatico() {
        await this.exibirModalSignatarios();
        this.modalCadastro = true;
        Metadata.getInstance<Text>('titleText').text = 'Cadastramento Automático';
        Metadata.getInstance<Select>('IDTPSIGNATARIO').isVisible = false;
        Metadata.getInstance<Select>('IDTPSIGNATARIO').clearValidations();
        Metadata.getInstance<Select>('IDTIPOASSINATURA').value = 'E';
        Metadata.getInstance<Select>('IDTESTEMUNHA').value = 'N';
        Metadata.getInstance<Select>('IDINSERCAOAUTO').value = 'P';
        Metadata.getInstance<TextInput>('NRINSCRICAOPARC').isVisible = false;
    }

    public async abrirModalEdicaoSignatarios({ row }: any) {
        await this.exibirModalSignatarios();
        this.modalCadastro = false;
        Metadata.getInstance<Text>('titleText').text = 'Editar Signatário Padrão';
        Metadata.getInstance<TextInput>('NRINSCRICAOPARC').isVisible = true;
        Metadata.getInstance<TextInput>('NRINSCRICAOPARC').readonly = true;
        Metadata.getInstance<Select>('IDTPSIGNATARIO').readonly = true;
        Metadata.getInstance<Select>('NRPARCNEGOCIO').readonly = true;
        Metadata.getInstance<Select>('NRPARCNEGOCIO').clearValidations();
        Metadata.getInstance<Select>('IDTPSIGNATARIO').value = row.IDTPSIGNATARIO;
        Metadata.getInstance<TextInput>('NRINSCRICAOPARC').value = row.NRINSCRICAOPARC;
        const nrparcnegocio = [row.NRPARCNEGOCIO];
        Metadata.getInstance<Select>('NRPARCNEGOCIO').value = nrparcnegocio;
        Metadata.getInstance<Select>('IDTIPOASSINATURA').value = row.IDTIPOASSINATURA;
        Metadata.getInstance<Select>('IDTESTEMUNHA').value = row.IDTESTEMUNHA;
        Metadata.getInstance<Number>('NRORDENACAO').value = row.NRORDENACAO;
        Metadata.getInstance<Select>('formDadosNotificacaoAssinatura-DSEMAILNOTSIGNENV_INS').value = row.DSEMAILNOTSIGNENV;
        Metadata.getInstance<Select>('formDadosNotificacaoAssinatura-OPERADORES').value = row.OPERADORES;
        Metadata.getInstance<TextInput>('formDadosNotificacaoAssinatura-DSEMAILNOTIFOUTROS').value = row.DSEMAILNOTIFOUTROS;
        Metadata.getInstance<Select>('IDINSERCAOAUTO').value = row.IDINSERCAOAUTO;
        Metadata.getInstance<TextInput>('NRSIGNATARIOSPADR').value = row.NRSIGNATARIOSPADR;
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public controlaSignatario() {
        if (Metadata.getInstance<Select>('IDTPSIGNATARIO').value === 'SE') {
            Metadata.getInstance<Select>('IDTPSIGNATARIO').value = 'SE';
            Metadata.getInstance<Select>('IDTIPOASSINATURA').value = 'E';
            Metadata.getInstance<Select>('IDTESTEMUNHA').value = 'N';
            Metadata.getInstance<Select>('IDINSERCAOAUTO').value = 'P';
            if (Metadata.getInstance<TextInput>('NRSIGNATARIOSPADR').value == null) {
                Metadata.getInstance<Select>('NRPARCNEGOCIO').readonly = false;
            } else {
                Metadata.getInstance<Select>('NRPARCNEGOCIO').readonly = true;
            }
            Metadata.getInstance<Select>('IDTIPOASSINATURA').readonly = false;
            Metadata.getInstance<Select>('IDTESTEMUNHA').readonly = false;
        } else {
            Metadata.getInstance<Select>('NRPARCNEGOCIO').clearValidations();
            Metadata.getInstance<Select>('NRPARCNEGOCIO').readonly = true;
            Metadata.getInstance<Select>('IDTIPOASSINATURA').readonly = true;
            Metadata.getInstance<Select>('IDTESTEMUNHA').readonly = true;
            Metadata.getInstance<Select>('IDTIPOASSINATURA').value = 'E';
            Metadata.getInstance<Select>('NRPARCNEGOCIO').value = null;
            if (['SC', 'SP'].includes(Metadata.getInstance<Select>('IDTPSIGNATARIO').value)) {
                Metadata.getInstance<Select>('IDTESTEMUNHA').value = 'N';
            } else if (['TC', 'TP'].includes(Metadata.getInstance<Select>('IDTPSIGNATARIO').value)) {
                Metadata.getInstance<Select>('IDTESTEMUNHA').value = 'S';
            }
        }
    }

    public saveSignatariosPadroes() {
        const formSignatarios = Metadata.getInstance<Form>('form_modal_signatarios');
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-signatarios');
        if (Utilities.validateForm(formSignatarios)) {
            if (this.modalCadastro === false) {
                LoadingService.show();
                Http.post('/saveSignatariosPadroes', {
                    IDTPSIGNATARIO: Metadata.getInstance<Select>('IDTPSIGNATARIO').value,
                    NRPARCNEGOCIO: Metadata.getInstance<Select>('NRPARCNEGOCIO').value,
                    IDTIPOASSINATURA: Metadata.getInstance<Select>('IDTIPOASSINATURA').value,
                    IDTESTEMUNHA: Metadata.getInstance<Select>('IDTESTEMUNHA').value,
                    NRORDENACAO: Metadata.getInstance<Number>('NRORDENACAO').value,
                    IDINSERCAOAUTO: Metadata.getInstance<Select>('IDINSERCAOAUTO').value,
                    DSEMAILNOTSIGNENV: Metadata.getInstance<Select>('formDadosNotificacaoAssinatura-DSEMAILNOTSIGNENV_INS').value,
                    OPERADORES: Metadata.getInstance<Select>('formDadosNotificacaoAssinatura-OPERADORES').value,
                    DSEMAILNOTIFOUTROS: Metadata.getInstance<TextInput>('formDadosNotificacaoAssinatura-DSEMAILNOTIFOUTROS').value,
                    NRSIGNATARIOSPADR: Metadata.getInstance<TextInput>('NRSIGNATARIOSPADR').value,
                }).then(() => {
                    this.fecharModalSignatarios();
                    grid.datasource.get();
                    Utilities.showSuccessMessage();
                }).catch((error) => {
                    if (error.response.data.error === 'EXISTE') {
                        Utilities.showDialogMessage('error', 'Operação bloqueada!', 'O signatário informado já foi inserido.');
                    } else {
                        Utilities.showErrorMessage(error);
                    }
                }).finally(() => {
                    LoadingService.hide();
                });
            } else {
                LoadingService.show();
                Http.post('/cadAutoSignatPadr', {
                    IDTPSIGNATARIO: Metadata.getInstance<Select>('IDTPSIGNATARIO').value,
                    NRPARCNEGOCIO: Metadata.getInstance<Select>('NRPARCNEGOCIO').value,
                    IDTIPOASSINATURA: Metadata.getInstance<Select>('IDTIPOASSINATURA').value,
                    IDTESTEMUNHA: Metadata.getInstance<Select>('IDTESTEMUNHA').value,
                    NRORDENACAO: Metadata.getInstance<Number>('NRORDENACAO').value,
                    IDINSERCAOAUTO: Metadata.getInstance<Select>('IDINSERCAOAUTO').value,
                    DSEMAILNOTSIGNENV: Metadata.getInstance<Select>('formDadosNotificacaoAssinatura-DSEMAILNOTSIGNENV_INS').value,
                    OPERADORES: Metadata.getInstance<Select>('formDadosNotificacaoAssinatura-OPERADORES').value,
                    DSEMAILNOTIFOUTROS: Metadata.getInstance<TextInput>('formDadosNotificacaoAssinatura-DSEMAILNOTIFOUTROS').value,
                    NRSIGNATARIOSPADR: Metadata.getInstance<TextInput>('NRSIGNATARIOSPADR').value,
                }).then(() => {
                    this.fecharModalSignatarios();
                    grid.datasource.get();
                    Utilities.showSuccessMessage();
                }).catch((error) => {
                    Utilities.showErrorMessage(error);
                }).finally(() => {
                    LoadingService.hide();
                });
            }
        }
    }

    public showConfirmDeleteMessageSignatarios({ event }: any) {
        event!.preventDefault();
        DialogService.show({
            name: 'buttons-dialog-operador',
            type: 'warning',
            title: 'Excluir Registro',
            text: 'Deseja realmente excluir todos os registros selecionados?',
            buttons: [
                {
                    name: 'NAO',
                    component: 'ZdButton',
                    label: 'Não',
                    outline: true,
                    events: {
                        click: () => {
                            DialogService.hide();
                        },
                    },
                },
                {
                    name: 'SIM',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            this.deleteParametrosSignatario();
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public deleteParametrosSignatario() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-signatarios');
        LoadingService.show();
        Http.post('/deleteParametrosSignatario', grid.selectedRows)
            .then(() => {
                grid.datasource.get();
                Utilities.showSuccessMessage();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }
}
